<?php

// ==============================================================
// ===   classe entity + est utilisee par toutes les tables  ====
// ==============================================================
class entity extends MYSQL {

	protected $table;
	public $id;
	protected $primaryKey;
	/**  Variable pour les donnes surcharges.  */
    private $data = array();
    // le constructeur 
	public function __construct($table = null) 
	{
		parent::__construct();
		if(is_null($table))
			return 'Table non specifiee pour ' . __CLASS__;
		$this->setTableName($table);
		$this->primaryKey = $this->getPrimaryKey($this->table);
	}
	// Methode pour affecte le nom de la table
	protected function setTableName($tableName) 
	{
		$this->table = $tableName;
	}
	// Methode pour affecte le nom de la table
	public function alterTable($clause=null) 
	{
		$sql = "ALTER TABLE `$this->table` ";
		if(!is_null($clause)) 
		{
		    $sql .=$clause;
		}
		if (parent::complete($sql))
			return true;
		else
			return parent::error();
	}
	// Methode pour avoir la cle primaire
	public function getPrimaryKey($table) 
	{
		$sql = "SHOW KEYS FROM $table WHERE Key_name = 'PRIMARY'";
		$res = $this->execRequete($sql);
		$result = $this->ligneSuivante($res);
		return $result['Column_name'];
	}
	// Methode pour avoir tous les champs de la tables
	public function getAllFields() 
	{
		$fieldList = array();
		$req = "SHOW FIELDS FROM $this->table";
		$res = $this->execRequete($req);
		foreach($res as $f)
			$fieldList[] = $f['Field'];
		return $fieldList;
	}
	
	// Methode pour avoir tous les champs de la tables
	public function getOneFields($champs) 
	{
		$req = "SHOW COLUMNS  FROM $this->table LIKE '$champs'";
		$res = $this->execRequete($req);
		//echo $req. ' = ' ;
		if($this->nbreLigne ($res) > 0)
	    {
			$retour='1';
		}
		else
			$retour='0';
		//echo $this->nbreLigne ($res).'<br />';		
		return $retour;	
	}
	// Methode pour avoir tous les champs de la tables
	public function addFields($champs) 
	{
		$req = "ALTER TABLE $this->table ADD COLUMN '$champs'";
		
		parent::complete($req);
	}
	
	/** Methode de sauvegarde ou de mise a jour d'un enregistrement */
	public function saveRecord($post, $exceptions = null) 
	{
		if($exceptions)
			if(is_array($exceptions))
				foreach($exceptions as $e)
					unset($post[$e]);
		if(isset($post[$this->primaryKey])) empty($post[$this->primaryKey]) ? $this->newRecord($post) : $this->updateRecord($post);
		else $this->newRecord($post);
		
	}
	
	/** Methode de sauvegarde d'un nouvel enregistrement */
	public function newRecord($post) 
	{
		$sql = "INSERT INTO `$this->table` ";
		$vals = "";$champs = "";
	
		foreach($post as $cle => $val){
			if($champs == "" && $vals == ""){
				$champs .= $cle;
				$vals .= "'".parent::prepareChaine(code($val))."'";
			}else{
				$champs .= ",".$cle;
				$vals .= ",'".parent::prepareChaine(code($val))."'";
			}
		}
		$sql .= "(".$champs.") VALUES (".$vals.")";
		//echo $sql;
		if (parent::complete($sql))
			return true; 
		else
		 return parent::error();  
	 
	}
	
	/** Methode de mise a jour d'un enregistrement */
	public function updateRecord($post) 
	{
		$valeurs = "";
		$sql = "UPDATE `$this->table` SET ";
	
		foreach($post as $cle => $val){
			if($valeurs == "")
				$valeurs .= $cle."='".parent::prepareChaine( code($val))."'";
			else
				$valeurs .= ",".$cle."='".parent::prepareChaine(code($val))."'";
		}
	
		$sql .= $valeurs." WHERE $this->primaryKey = ".$post["$this->primaryKey"];
		//echo $sql;
		if (parent::complete($sql))
			return true;
		else
			return parent::error();
	}
	/** Methode pour avoir un enregistrement suivant l'id */
	public function getRecord($id)
	{
		if(is_array($id)) {
			$req = "SELECT * FROM $this->table WHERE ";
			foreach($id as $cle => $val) {
				$req .= "$cle = '$val' ";
			}
			$req .= " LIMIT 1";
			$res = $this->execRequete($req);
			if(empty($res)) {
				return null;
			} else {
				return $res[0];
			}
		}
		$req = "SELECT * FROM $this->table WHERE $this->primaryKey = '$id' LIMIT 1";
		//echo $req;
		$res = $this->execRequete($req);
		if($res!=null)
	    {
	      $result=$this->objetSuivant($res); 
	    }
	    else
	    	$result=null;
		return $result;
	}
	
	/** Methode pour avoir le dernier enregistrement*/
	public function getLastRecord()
	{
		$req = "SELECT * FROM $this->table WHERE $this->primaryKey = LAST_INSERT_ID() ";
		//echo $req;
		$res = $this->execRequete($req);
		if($res!=null)
	    {
	      $result=$this->objetSuivant($res); 
	    }
	    else
	    	$result=null;
		return $result;
	}
	/** Methode pour avoir le dernier enregistrement*/
	public function getOneRecord($clause=null)
	{
		$req = "SELECT * FROM $this->table ";
		
		
		if(!is_null($clause)) {
		    $req .=$clause;
		}
		$req .=" LIMIT 0,1";
		//echo $req;
		$res = $this->execRequete($req);
		if($res!=null)
	    {
	      $result=$this->objetSuivant($res); 
	    }
	    else
	    	$result=null;
	    return $result;
	}
	/** Methode avoir tous les enregistrement suivant les critere */
	public function getAllRecords($filter = null, $clause=null) 
	{
		$req = "SELECT * FROM $this->table ";
		if(!is_null($filter)) {
			$req .= " WHERE 1";
			foreach($filter as $k => $v) {
				$req .= " and $k = '$v' ";
			}
		}
		
		if(!is_null($clause)) {
		    $req .=$clause;
		}
		//echo $req;
		$res = $this->execRequete($req);
		if($res!=null)
	    {
	      $result=$this->objetSuivant($res); 
	    }
	    else
	    	$result=null;
	    return $result;
	}
	public function getJoinAllRecords($filter = null,$table=null, $clause=null) 
	{
		$req = "SELECT $this->table.*,$table.* FROM $this->table,$table ";
		if(!is_null($filter)) {
			$req .= " WHERE 1";
			foreach($filter as $k => $v) {
				$req .= " and $k = '$v' ";
			}
		}
		
		if(!is_null($clause)) {
		    $req .=$clause;
		}
		//echo $req;
		$res = $this->execRequete($req);
		if($res!=null)
	    {
	      $result=$this->objetSuivant($res); 
	    }
	    else
	    	$result=null;
	    return $result;
	}
	public function getListRecords($clause=null) 
	{
		$req = "SELECT * FROM $this->table ";
		if(!is_null($clause)) {
		    $req .=$clause;
		}
		//echo $req;
		$request = $this->execRequete($req);
		if($this->nbreLigne ($request) > 0)
	    {
			$retour=$request;
		}
		else
			$retour=null;
		return $retour;	
	}
	public function getListDistinct($clause=null,$filter=null) 
	{
		$req = "SELECT DISTINCT ".$filter." FROM $this->table ";
		
		if(!is_null($clause)) {
		    $req .=$clause;
		}
		//echo $req;
		$request = $this->execRequete($req);
		if($this->nbreLigne ($request) > 0)
	    {
			$retour=$request;
		}
		else
			$retour=null;
		return $retour;	
	}
	public function getRowRecords($clause=null) 
	{
		$req = "SELECT * FROM $this->table ";
		if(!is_null($clause)) {
		    $req .=$clause;
		}
		//echo $req;
		$request = $this->execRequete($req);
		$retour=$this->nbreLigne ($request);
		return $retour;	
	}
	public function getCountRecords($clause=null) 
	{
		$req = "SELECT COUNT(*) AS nb FROM $this->table ";
		if(!is_null($clause)) {
		    $req .=$clause;
		}
		//echo $req;
		$request = $this->execRequete($req);
		if($request!=null)
	    {
	     	while ($result=$this->objetSuivant($request))
	     	$count=$result->nb;
			
	    }
	    else
	    	$count='0';
	    //echo $count;
	    return $count;
	}
	/** Methode pour effacer enregistrement */
	public function delRecord($id) {
		$id = is_array($id) ? $id["$this->primaryKey"] : $id;
		$req = "DELETE FROM $this->table WHERE ".$this->primaryKey." = '$id';";
		parent::complete($req);
	}
	/** Methode pour effacer enregistrement */
	public function delAllRecord($clause=null) {
		if(!is_null($clause)) {
		    $req ="DELETE FROM $this->table  $clause";
		}
		parent::complete($req);
	}
	
	
}

class Sender{ 
/* 
* the server where the modems hosted 
*/  
var  $host; 
/* 
* Username that is to be used for submission 
*/  
var $strUserName; 
/* 
* password that is to be used along with username 
*/ 
var $strPassword; 
/* 
* Sender Id to be used for submitting the message 
*/ 
var $strSender; 
/* 
* Message content that is to be transmitted 
*/ 
var $strMessage; 
/* 
* Mobile No is to be transmitted. 
*/ 
var $strMobile; 
/* 
* The date when the sms will be sent. 
*/ 
var $strDate; 
/* 
* What type of the message that is to be sent 
*/ 
var $strMessageType; 
/* 
* Require DLR or not 
*/ 
var $strDlr; 
private function sms__unicode($message) 
{ 
$hex1=''; 
if (function_exists('iconv'))  
{ 
$latin = @iconv('UTF-8', 'ISO-8859-1', $message); 
if (strcmp($latin, $message))  
{ 
$arr = unpack('H*hex', @iconv('UTF-8', 'UCS-2BE', $message)); 
$hex1 = strtoupper($arr['hex']); 
} 
If ($hex1 =='') 
{  
$hex2=''; 
$hex=''; 
for ($i=0; $i < strlen($message); $i++ ) 
{ 
$hex = dechex(ord($message[$i])); 
$len =strlen($hex); 
$add = 4 - $len; 
If ($len < 4) 
{ 
for ($j=0;$j<$add; $j++ ) 
{ 
$hex="0".$hex;  
} 
} 
$hex2.=$hex; 
} 
return $hex2; 
} 
else 
{ 
return $hex1; 
} 
} 
else 
{ 
 print 'iconv Function Not Exists !'; 
} 
} 
//Constructor.. 
public function Sender ($host,$username,$password,$sender,$message,$mobile,$date) 
{ 
$this->host=$host; 
$this->strUserName = $username; 
$this->strPassword = $password; 
$this->strSender= $sender; 
$this->strMessage=$message; //URL Encode The Message.. 
$this->strMobile=$mobile; 
$this->strDate=$date; 
} 
public function Submit() 
{ 
if($this->strMessageType=="2" || $this->strMessageType=="6")  
{ 
$this->strMessage = $this->sms__unicode($this->strMessage);  
//Call The Function Of String To HEX. 
echo $this->strMessage; 
exit; 
} 
else 
$this->strMessage=urlencode($this->strMessage); 
try 
 { 
//Smpp http Url to send sms. 
$live_url=$this->host."/api.php?account=".$this->strUserName."&pwd=".$this->strPassword."&dest=".$this->strMobile."&expediteur=".$this->strSender."&msg=".$this->strMessage."&date=".$this->strDate.""; 
 
 //echo $live_url;
$parse_url=file( $live_url); 
} 
catch(Exception $e) 
{ 
echo  'Message:' .$e->getMessage(); 
} 
} 
} 

?>